// Generated by CoffeeScript 1.6.3
var app, contributor, cors, error, express, query, request, validate, _;

_ = require('lodash');

contributor = require('./contributor');

cors = require('cors');

express = require('express');

request = require('request');

app = express();

app.use(cors());

app.use(express.logger());

validate = function(req, res) {
  if (!(_.keys(req.query)).length) {
    return error(res, 400, 'Error: API requires one or more identities passed as query parameters');
  }
};

error = function(res, code, message) {
  return res.send(code, {
    status: code,
    message: message || ''
  });
};

query = function(res, identities) {
  return (contributor(identities)).then(function(counts) {
    return res.send(200, counts);
  }, function(e) {
    return error(res, 404, e);
  });
};

app.get('/api', function(req, res) {
  var identities, options, param, platform, _i, _len, _ref;
  identities = {};
  validate(req, res);
  _ref = contributor.support;
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    platform = _ref[_i];
    param = req.query[platform];
    if (param) {
      identities[platform] = param;
    }
  }
  if (process.env.github_oauth_token) {
    options = {
      url: 'https://api.github.com/user',
      auth: {
        user: "" + process.env.github_oauth_token + ":x-oauth-basic"
      }
    };
    return request(options, function(e) {
      if (e !== null) {
        throw new Error(e);
      }
      return query(res, identities);
    });
  } else {
    return query(res, identities);
  }
});

exports.app = app;
